diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java
index 293c58a70..52c6c1440 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java
@@ -11,239 +11,233 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkDecorator;
+import net.minecraft.core.world.generate.chunk.ChunkFeatureDecorator;
 import net.minecraft.core.world.generate.feature.*;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancy;
 import net.minecraft.core.world.noise.PerlinNoise;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
 public class ChunkDecoratorOverworldHell
-    implements ChunkDecorator
-{
-    private final World world;
+    extends ChunkFeatureDecorator {
     private final PerlinNoise treeDensityNoise;
 
-    public ChunkDecoratorOverworldHell(World world)
-    {
-        this.world = world;
-
-        treeDensityNoise = new PerlinNoise(world.getRandomSeed(), 8, 74);
+    public ChunkDecoratorOverworldHell(final @NotNull World world) {
+        super(world);
+        this.treeDensityNoise = new PerlinNoise(world.getRandomSeed(), 8, 74);
     }
 
     @Override
-    public void decorate(Chunk chunk)
-    {
-        int chunkX = chunk.xPosition;
-        int chunkZ = chunk.zPosition;
-
-        int minY = world.getWorldType().getMinY();
-        int maxY = world.getWorldType().getMaxY();
-        int rangeY = (maxY + 1) - minY;
-
-//        float oreHeightModifier = rangeY / 128f;
-
-        BlockLogicSand.fallInstantly = true;
-        int x = chunkX * 16;
-        int z = chunkZ * 16;
-//        int y = world.getHeightValue(x + 16, z + 16);
-//        Biome biome = world.getBlockBiome(x + 16, y, z + 16);
-        Random rand = new Random(world.getRandomSeed());
-        long l1 = (rand.nextLong() / 2L) * 2L + 1L;
-        long l2 = (rand.nextLong() / 2L) * 2L + 1L;
-        rand.setSeed((long)chunkX * l1 + (long) chunkZ * l2 ^ world.getRandomSeed());
-        if(rand.nextInt(32) == 0)
-        {
-            int i1 = x + rand.nextInt(16) + 8;
-            int l4 = minY + rand.nextInt(rangeY);
-            int i8 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureLake(Blocks.FLUID_LAVA_STILL.id())).place(world, rand, i1, l4, i8);
-        }
-        if(rand.nextInt(16) == 0)
-        {
-            int j1 = x + rand.nextInt(16) + 8;
-            int i5 = minY + rand.nextInt(rangeY - 16) + 8;
-            int j8 = z + rand.nextInt(16) + 8;
-
-            if(i5 < minY + rangeY / 2 || rand.nextInt(10) == 0)
-            {
-                if(rand.nextInt(4) == 0)
-                {
-                    (new WorldFeatureLake(Blocks.OBSIDIAN.id())).place(world, rand, j1, i5, j8);
-                }
-                else
-                {
-                    (new WorldFeatureLake(Blocks.FLUID_LAVA_STILL.id())).place(world, rand, j1, i5, j8);
+    public void registerDecorations() {
+        this.register(0, (world, chunk, worldX, worldZ, minY, maxY, rangeY, rand) -> {
+            if (rand.nextInt(32) == 0) {
+                final int xx = worldX + rand.nextInt(16) + 8;
+                final int yy = minY + rand.nextInt(rangeY);
+                final int zz = worldZ + rand.nextInt(16) + 8;
+                (new WorldFeatureLake(Blocks.FLUID_LAVA_STILL.id())).place(world, rand, xx, yy, zz);
+            }
+        });
+
+        this.register(1, (world, chunk, worldX, worldZ, minY, maxY, rangeY, rand) -> {
+            if (rand.nextInt(16) == 0) {
+                final int xx = worldX + rand.nextInt(16) + 8;
+                final int yy = minY + rand.nextInt(rangeY - 16) + 8;
+                final int zz = worldZ + rand.nextInt(16) + 8;
+
+                if (yy < minY + rangeY / 2 || rand.nextInt(10) == 0) {
+                    if (rand.nextInt(4) == 0) {
+                        (new WorldFeatureLake(Blocks.OBSIDIAN.id())).place(world, rand, xx, yy, zz);
+                    } else {
+                        (new WorldFeatureLake(Blocks.FLUID_LAVA_STILL.id())).place(world, rand, xx, yy, zz);
+                    }
                 }
             }
-        }
-
-        for(int l18 = 0; l18 < 50; l18++)
-        {
-            int l21 = x + rand.nextInt(16) + 8;
-            int k23 = minY + rand.nextInt(rangeY / 2);
-            int l24 = z + rand.nextInt(16) + 8;
-            if(k23 < minY + rangeY / 2) {
-                (new WorldFeatureLiquid(Blocks.FLUID_WATER_FLOWING.id())).place(world, rand, l21, k23, l24);
+        });
+
+        this.register(2, (world, chunk, worldX, worldZ, minY, maxY, rangeY, rand) -> {
+            for (int i = 0; i < 50; i++) {
+                final int xx = worldX + rand.nextInt(16) + 8;
+                final int yy = minY + rand.nextInt(rangeY / 2);
+                final int zz = worldZ + rand.nextInt(16) + 8;
+                if (yy < minY + rangeY / 2) {
+                    (new WorldFeatureLiquid(Blocks.FLUID_WATER_FLOWING.id())).place(world, rand, xx, yy, zz);
+                }
             }
-        }
-        for(int k1 = 0; k1 < 8; k1++)
-        {
-            int j5 = x + rand.nextInt(16) + 8;
-            int k8 = minY + rand.nextInt(rangeY);
-            int j11 = z + rand.nextInt(16) + 8;
-            if (rand.nextInt(2) == 0)
-            {
-                (new WorldFeatureDungeon(Blocks.BRICK_CLAY.id(), Blocks.BRICK_CLAY.id(), null)).place(world, rand, j5, k8, j11);
-            }
-            else
-            {
-                (new WorldFeatureDungeon(Blocks.COBBLE_STONE.id(), Blocks.COBBLE_STONE_MOSSY.id(), null)).place(world, rand, j5, k8, j11);
+        });
+
+        this.register(3, (world, chunk, worldX, worldZ, minY, maxY, rangeY, rand) -> {
+            for (int i = 0; i < 8; i++) {
+                final int xx = worldX + rand.nextInt(16) + 8;
+                final int yy = minY + rand.nextInt(rangeY);
+                final int zz = worldZ + rand.nextInt(16) + 8;
+                if (rand.nextInt(2) == 0) {
+                    (new WorldFeatureDungeon(Blocks.BRICK_CLAY.id(), Blocks.BRICK_CLAY.id(), null)).place(world, rand, xx, yy, zz);
+                } else {
+                    (new WorldFeatureDungeon(Blocks.COBBLE_STONE.id(), Blocks.COBBLE_STONE_MOSSY.id(), null)).place(world, rand, xx, yy, zz);
+                }
             }
-        }
+        });
 
-        for(int k1 = 0; k1 < 1; k1++)
-        {
-            int j5 = x + rand.nextInt(16) + 8;
-            int j11 = z + rand.nextInt(16) + 8;
-            int k8 = world.getHeightValue(j5, j11) - (rand.nextInt(2)+2);
+        this.register(4, (world, chunk, worldX, worldZ, minY, maxY, rangeY, rand) -> {
+            for (int i = 0; i < 1; i++) {
+                final int xx = worldX + rand.nextInt(16) + 8;
+                final int zz = worldZ + rand.nextInt(16) + 8;
+                int yy = world.getHeightValue(xx, zz) - (rand.nextInt(2) + 2);
 
-            //chance to sink labyrinth
-            if(rand.nextInt(10)==0)
-                k8 -= rand.nextInt(10)+30;
+                //chance to sink labyrinth
+                if (rand.nextInt(10) == 0)
+                    yy -= rand.nextInt(10) + 30;
 
-            if(rand.nextInt(512) == 0) {
-                (new WorldFeatureLabyrinth()).place(world, rand, j5, k8, j11);
+                if (rand.nextInt(512) == 0) {
+                    (new WorldFeatureLabyrinth()).place(world, rand, xx, yy, zz);
+                }
             }
-        }
-
-        for(int i2 = 0; i2 < 20; i2++)
-        {
-            int k5 = x + rand.nextInt(16);
-            int l8 = minY + rand.nextInt(rangeY);
-            int k11 = z + rand.nextInt(16);
-            (new WorldFeatureClay(32)).place(world, rand, k5, l8, k11);
-        }
-
-        for(int j2 = 0; j2 < 20; j2++)
-        {
-            int l5 = x + rand.nextInt(16);
-            int i9 = minY + rand.nextInt(rangeY);
-            int l11 = z + rand.nextInt(16);
-            (new WorldFeatureOre(Blocks.DIRT.id(), 32)).place(world, rand, l5, i9, l11);
-        }
-
-        for(int k2 = 0; k2 < 10; k2++)
-        {
-            int i6 = x + rand.nextInt(16);
-            int j9 = minY + rand.nextInt(rangeY);
-            int i12 = z + rand.nextInt(16);
-            (new WorldFeatureOre(Blocks.GRAVEL.id(), 32)).place(world, rand, i6, j9, i12);
-        }
-
-        for(int i3 = 0; i3 < 20; i3++)
-        {
-            int j6 = x + rand.nextInt(16);
-            int k9 = minY + rand.nextInt(rangeY);
-            int j12 = z + rand.nextInt(16);
-            (new WorldFeatureOre(BlockLogicOreCoal.variantMap, 16)).place(world, rand, j6, k9, j12);
-        }
-
-        for(int j3 = 0; j3 < 20; j3++)
-        {
-            int k6 = x + rand.nextInt(16);
-            int l9 = minY + rand.nextInt(rangeY / 2);
-            int k12 = z + rand.nextInt(16);
-            (new WorldFeatureOre(BlockLogicOreIron.variantMap, 8)).place(world, rand, k6, l9, k12);
-        }
-
-        for(int k3 = 0; k3 < 2; k3++)
-        {
-            int l6 = x + rand.nextInt(16);
-            int i10 = minY + rand.nextInt(rangeY / 4);
-            int l12 = z + rand.nextInt(16);
-            (new WorldFeatureOre(BlockLogicOreGold.variantMap, 8)).place(world, rand, l6, i10, l12);
-        }
-
-        for(int l3 = 0; l3 < 8; l3++)
-        {
-            int i7 = x + rand.nextInt(16);
-            int j10 = minY + rand.nextInt(rangeY / 8);
-            int i13 = z + rand.nextInt(16);
-            (new WorldFeatureOre(BlockLogicOreRedstone.variantMap, 7)).place(world, rand, i7, j10, i13);
-        }
-
-        for(int i4 = 0; i4 < 1; i4++)
-        {
-            int j7 = x + rand.nextInt(16);
-            int k10 = minY + rand.nextInt(rangeY / 8);
-            int j13 = z + rand.nextInt(16);
-            (new WorldFeatureOre(BlockLogicOreDiamond.variantMap, 7)).place(world, rand, j7, k10, j13);
-        }
-
-        for(int j4 = 0; j4 < 1; j4++)
-        {
-            int k7 = x + rand.nextInt(16);
-            int l10 = minY + rand.nextInt(rangeY / 8) + rand.nextInt(rangeY / 8);
-            int k13 = z + rand.nextInt(16);
-            (new WorldFeatureOre(BlockLogicOreLapis.variantMap, 6)).place(world, rand, k7, l10, k13);
-        }
-
-        double d = 0.5D;
-        int treeDensity = (int)((treeDensityNoise.get((double)x * d, (double)z * d) / 8D + rand.nextDouble() * 4D + 4D) / 3D);
-        if(rand.nextInt(10) == 0)
-        {
-            treeDensity++;
-        }
-        treeDensity /= 2;
-        for(int i11 = 0; i11 < treeDensity; i11++)
-        {
-            boolean hasLeaves = rand.nextInt(1234) == 0;
-            int l13 = x + rand.nextInt(16) + 8;
-            int j14 = z + rand.nextInt(16) + 8;
-            WorldFeature wf;
-            if(rand.nextInt(10) == 0)
-            {
-                wf = new WorldFeatureTreeFancy(hasLeaves ? Blocks.LEAVES_OAK.id() : 0, Blocks.LOG_OAK.id());
-            } else
-            {
-                wf = new WorldFeatureTree(hasLeaves ? Blocks.LEAVES_OAK.id() : 0, Blocks.LOG_OAK.id(), 4);
-            }
-            wf.init(1.0D, 1.0D, 1.0D);
-            wf.place(world, rand, l13, world.getHeightValue(l13, j14), j14);
-        }
+        });
+
+        this.register(5, (world, chunk, worldX, worldZ, minY, maxY, rangeY, rand) -> {
+            for (int i = 0; i < 20; i++) {
+                final int xx = worldX + rand.nextInt(16);
+                final int yy = minY + rand.nextInt(rangeY);
+                final int zz = worldX + rand.nextInt(16);
+                (new WorldFeatureClay(32)).place(world, rand, xx, yy, zz);
+            }
+        });
+
+        this.register(6, (world, chunk, worldX, worldZ, minY, maxY, rangeY, rand) -> {
+            for (int i = 0; i < 20; i++) {
+                final int xx = worldX + rand.nextInt(16);
+                final int yy = minY + rand.nextInt(rangeY);
+                final int zz = worldZ + rand.nextInt(16);
+                (new WorldFeatureOre(Blocks.DIRT.id(), 32)).place(world, rand, xx, yy, zz);
+            }
+        });
+
+        this.register(7, (world, chunk, worldX, worldZ, minY, maxY, rangeY, rand) -> {
+            for (int i = 0; i < 10; i++) {
+                final int xx = worldX + rand.nextInt(16);
+                final int yy = minY + rand.nextInt(rangeY);
+                final int zz = worldZ + rand.nextInt(16);
+                (new WorldFeatureOre(Blocks.GRAVEL.id(), 32)).place(world, rand, xx, yy, zz);
+            }
+        });
+
+        this.register(8, (world, chunk, worldX, worldZ, minY, maxY, rangeY, rand) -> {
+            for (int i = 0; i < 20; i++) {
+                final int xx = worldX + rand.nextInt(16);
+                final int yy = minY + rand.nextInt(rangeY);
+                final int zz = worldZ + rand.nextInt(16);
+                (new WorldFeatureOre(BlockLogicOreCoal.variantMap, 16)).place(world, rand, xx, yy, zz);
+            }
+        });
+
+        this.register(9, (world, chunk, worldX, worldZ, minY, maxY, rangeY, rand) -> {
+            for (int i = 0; i < 20; i++) {
+                final int xx = worldX + rand.nextInt(16);
+                final int yy = minY + rand.nextInt(rangeY / 2);
+                final int zz = worldZ + rand.nextInt(16);
+                (new WorldFeatureOre(BlockLogicOreIron.variantMap, 8)).place(world, rand, xx, yy, zz);
+            }
+        });
+
+        this.register(10, (world, chunk, worldX, worldZ, minY, maxY, rangeY, rand) -> {
+            for (int i = 0; i < 2; i++) {
+                final int xx = worldX + rand.nextInt(16);
+                final int yy = minY + rand.nextInt(rangeY / 4);
+                final int zz = worldZ + rand.nextInt(16);
+                (new WorldFeatureOre(BlockLogicOreGold.variantMap, 8)).place(world, rand, xx, yy, zz);
+            }
+        });
+
+        this.register(11, (world, chunk, worldX, worldZ, minY, maxY, rangeY, rand) -> {
+            for (int i = 0; i < 8; i++) {
+                final int xx = worldX + rand.nextInt(16);
+                final int yy = minY + rand.nextInt(rangeY / 8);
+                final int zz = worldZ + rand.nextInt(16);
+                (new WorldFeatureOre(BlockLogicOreRedstone.variantMap, 7)).place(world, rand, xx, yy, zz);
+            }
+        });
+
+        this.register(12, (world, chunk, worldX, worldZ, minY, maxY, rangeY, rand) -> {
+            for (int i = 0; i < 1; i++) {
+                final int xx = worldX + rand.nextInt(16);
+                final int yy = minY + rand.nextInt(rangeY / 8);
+                final int zz = worldZ + rand.nextInt(16);
+                (new WorldFeatureOre(BlockLogicOreDiamond.variantMap, 7)).place(world, rand, xx, yy, zz);
+            }
+        });
+
+        this.register(13, (world, chunk, worldX, worldZ, minY, maxY, rangeY, rand) -> {
+            for (int i = 0; i < 1; i++) {
+                final int xx = worldX + rand.nextInt(16);
+                final int yy = minY + rand.nextInt(rangeY / 8) + rand.nextInt(rangeY / 8);
+                final int zz = worldZ + rand.nextInt(16);
+                (new WorldFeatureOre(BlockLogicOreLapis.variantMap, 6)).place(world, rand, xx, yy, zz);
+            }
+        });
 
-        byte byte1 = 10;
-        for(int i15 = 0; i15 < byte1; i15++)
-        {
-            int i17 = x + rand.nextInt(16) + 8;
-            int i20 = minY + rand.nextInt(rangeY);
-            int l22 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureDeadBush(Blocks.DEADBUSH.id())).place(world, rand, i17, i20, l22);
-        }
+        this.register(14, (world, chunk, worldX, worldZ, minY, maxY, rangeY, rand) -> {
+            final double d = 0.5D;
+            int treeDensity = (int) ((this.treeDensityNoise.get((double) worldX * d, (double) worldZ * d) / 8D + rand.nextDouble() * 4D + 4D) / 3D);
+            if (rand.nextInt(10) == 0) {
+                treeDensity++;
+            }
+            treeDensity /= 2;
+            for (int i = 0; i < treeDensity; i++) {
+                final boolean hasLeaves = rand.nextInt(1234) == 0;
+                final int xx = worldX + rand.nextInt(16) + 8;
+                final int zz = worldZ + rand.nextInt(16) + 8;
+                final WorldFeature wf;
+                if (rand.nextInt(10) == 0) {
+                    wf = new WorldFeatureTreeFancy(hasLeaves ? Blocks.LEAVES_OAK.id() : 0, Blocks.LOG_OAK.id());
+                } else {
+                    wf = new WorldFeatureTree(hasLeaves ? Blocks.LEAVES_OAK.id() : 0, Blocks.LOG_OAK.id(), 4);
+                }
+                wf.init(1.0D, 1.0D, 1.0D);
+                wf.place(world, rand, xx, world.getHeightValue(xx, zz), zz);
+            }
+        });
+
+        this.register(15, (world, chunk, worldX, worldZ, minY, maxY, rangeY, rand) -> {
+            for (int i = 0; i < 10; i++) {
+                final int xx = worldX + rand.nextInt(16) + 8;
+                final int yy = minY + rand.nextInt(rangeY);
+                final int zz = worldZ + rand.nextInt(16) + 8;
+                (new WorldFeatureDeadBush(Blocks.DEADBUSH.id())).place(world, rand, xx, yy, zz);
+            }
+        });
+
+        this.register(16, (world, chunk, worldX, worldZ, minY, maxY, rangeY, rand) -> {
+            for (int i = 0; i < 5; i++) {
+                final int xx = worldX + rand.nextInt(16) + 8;
+                final int yy = minY + rand.nextInt(rand.nextInt(rangeY - 8) + 8);
+                final int zz = worldZ + rand.nextInt(16) + 8;
+                (new WorldFeatureLiquid(Blocks.FLUID_LAVA_FLOWING.id())).place(world, rand, xx, yy, zz);
+            }
+        });
+
+        this.register(17, ((world, chunk, worldX, worldZ, minY, maxY, rangeY, rand) -> {
+            for (int i = 0; i < 20; i++) {
+                final int xx = worldX + rand.nextInt(16) + 8;
+                final int yy = minY + rand.nextInt(rand.nextInt(rand.nextInt(rangeY - rangeY / 8) + 8) + 8);
+                final int zz = worldZ + rand.nextInt(16) + 8;
+                (new WorldFeatureLiquid(Blocks.FLUID_LAVA_FLOWING.id())).place(world, rand, xx, yy, zz);
+            }
+        }));
+    }
 
-        for(int l18 = 0; l18 < 5; l18++)
-        {
-            int l21 = x + rand.nextInt(16) + 8;
-            int k23 = minY + rand.nextInt(rand.nextInt(rangeY - 8) + 8);
-            int l24 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureLiquid(Blocks.FLUID_LAVA_FLOWING.id())).place(world, rand, l21, k23, l24);
-        }
+    @Override
+    public void postDecorate(@NotNull final World world, @NotNull final Chunk chunk) {
+        final int chunkX = chunk.xPosition;
+        final int chunkZ = chunk.zPosition;
+        final int worldX = chunkX * 16;
+        final int worldZ = chunkZ * 16;
 
-        for(int i19 = 0; i19 < 20; i19++)
-        {
-            int i22 = x + rand.nextInt(16) + 8;
-            int l23 = minY + rand.nextInt(rand.nextInt(rand.nextInt(rangeY - rangeY / 8) + 8) + 8);
-            int i25 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureLiquid(Blocks.FLUID_LAVA_FLOWING.id())).place(world, rand, i22, l23, i25);
-        }
+        final int minY = world.getWorldType().getMinY();
 
-        if (world.getBlockId(x, minY + world.getWorldType().getOceanY() - 1, z) == world.getWorldType().getOceanBlockId())
-        {
-            world.setBlockWithNotify(x, minY + world.getWorldType().getOceanY() - 1, z, world.getWorldType().getOceanBlockId());
+        if (world.getBlockId(worldX, minY + world.getWorldType().getOceanY() - 1, worldZ) == world.getWorldType().getOceanBlockId()) {
+            world.setBlockWithNotify(worldX, minY + world.getWorldType().getOceanY() - 1, worldZ, world.getWorldType().getOceanBlockId());
         }
-
-        BlockLogicSand.fallInstantly = false;
-
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLiquid.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLiquid.java
index 8dfb139ab..47d2a78bd 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLiquid.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLiquid.java
@@ -66,7 +66,7 @@ public class WorldFeatureLiquid extends WorldFeature
         {
             world.setBlockWithNotify(x, y, z, liquidBlockId);
             world.scheduledUpdatesAreImmediate = true;
-            Blocks.blocksList[liquidBlockId].updateTick(world, x, y, z, random);
+            Blocks.blocksList[liquidBlockId].updateTick(world, x, y, z, random, false);
             world.scheduledUpdatesAreImmediate = false;
         }
         return true;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherLava.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherLava.java
index 565b7a070..e9b913193 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherLava.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherLava.java
@@ -71,7 +71,7 @@ public class WorldFeatureNetherLava extends WorldFeature
         {
             world.setBlockWithNotify(x, y, z, blockId);
             world.scheduledUpdatesAreImmediate = true;
-            Blocks.blocksList[blockId].updateTick(world, x, y, z, random);
+            Blocks.blocksList[blockId].updateTick(world, x, y, z, random, false);
             world.scheduledUpdatesAreImmediate = false;
         }
         return true;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePebbles.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePebbles.java
new file mode 100644
index 000000000..299061d6c
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePebbles.java
@@ -0,0 +1,64 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicFlowerStackable;
+import net.minecraft.core.block.BlockLogicOverlayPebbles;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.Random;
+
+public class WorldFeaturePebbles extends WorldFeature {
+    private final int blockId;
+    private final int count;
+    private final boolean varyStackSize;
+
+    @MethodParametersAnnotation(names = { "blockId", "count", "varyStackSize" })
+    public WorldFeaturePebbles(final int blockId, final int count, final boolean varyStackSize) {
+        this.blockId = blockId;
+        this.count = count;
+        this.varyStackSize = varyStackSize;
+    }
+
+    @Override
+    public boolean place(final @NotNull World world, final @NotNull Random random, final int x, final int y, final int z) {
+        for (int i = 0; i < this.count; i++) {
+            final int xx = (x + random.nextInt(8)) - random.nextInt(8);
+            final int yy = (y + random.nextInt(4)) - random.nextInt(4);
+            final int zz = (z + random.nextInt(8)) - random.nextInt(8);
+            if (world.isAirBlock(xx, yy, zz) && BlockLogicOverlayPebbles.canSpawnOn(world.getBlock(xx, yy - 1, zz))) {
+                final int metadata;
+                if (Block.hasLogicClass(Blocks.getBlock(this.blockId), BlockLogicOverlayPebbles.class)) {
+                    final int stackSize;
+                    if (this.varyStackSize) {
+                        stackSize = getStackSize(random);
+                    } else {
+                        stackSize = 0;
+                    }
+
+                    metadata = BlockLogicFlowerStackable.setStackCount(0, stackSize);
+                } else {
+                    metadata = 0;
+                }
+                world.setBlockAndMetadata(xx, yy, zz, this.blockId, metadata);
+            }
+        }
+
+        return true;
+    }
+
+    private static int getStackSize(final @NotNull Random random) {
+        // 0 = 0-7 (8 chances)
+        // 1 = 8-13 (6 chances)
+        // 2 = 14-17 (4 chances)
+        final int odds = random.nextInt(18);
+        if (odds < 8) {
+            return 0;
+        } else if (odds < 14) {
+            return 1;
+        } else {
+            return 2;
+        }
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePillar.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePillar.java
index bcdf2cbff..fc3810948 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePillar.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePillar.java
@@ -101,7 +101,7 @@ public class WorldFeaturePillar
                 if (world.getBlockId(x - largerRadius + rx, y0 + ry, z - largerRadius + rz) == Blocks.COBBLE_NETHERRACK.id()) {
                     world.setBlockWithNotify(x - largerRadius + rx, y0 + ry, z - largerRadius + rz, Blocks.FLUID_LAVA_FLOWING.id());
                     world.scheduledUpdatesAreImmediate = true;
-                    Blocks.FLUID_LAVA_FLOWING.updateTick(world, x - largerRadius + rx, y0 + ry, z - largerRadius + rz, random);
+                    Blocks.FLUID_LAVA_FLOWING.updateTick(world, x - largerRadius + rx, y0 + ry, z - largerRadius + rz, random, false);
                     world.scheduledUpdatesAreImmediate = false;
                 }
             }
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java b/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
index 1c7425b77..8fd2dce1c 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
@@ -12,6 +12,7 @@ import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.Weathers;
 import net.minecraft.core.world.wind.WindProvider;
 import net.minecraft.core.world.wind.WindProviderGeneric;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
@@ -260,36 +261,36 @@ public abstract class WorldType {
             this.languageKey = languageKey;
         }
 
-        public static Properties of(String languageKey) {
+        public static @NotNull Properties of(String languageKey) {
             return new Properties(languageKey);
         }
 
-        public Properties defaultWeather(Weather weather) {
+        public @NotNull Properties defaultWeather(Weather weather) {
             this.defaultWeather = weather;
             return this;
         }
 
-        public Properties windManager(WindProvider windProvider) {
+        public @NotNull Properties windManager(WindProvider windProvider) {
             this.windProvider = windProvider;
             return this;
         }
 
-        public Properties withCeiling() {
+        public @NotNull Properties withCeiling() {
             this.hasCeiling = true;
             return this;
         }
 
-        public Properties brightnessRamp(float[] brightnessRamp) {
+        public @NotNull Properties brightnessRamp(float[] brightnessRamp) {
             this.brightnessRamp = brightnessRamp;
             return this;
         }
 
-        public Properties seasonConfig(SeasonConfig seasonConfig) {
+        public @NotNull Properties seasonConfig(SeasonConfig seasonConfig) {
             this.seasonConfig = seasonConfig;
             return this;
         }
 
-        public Properties bounds(int minY, int maxY, int oceanY) {
+        public @NotNull Properties bounds(int minY, int maxY, int oceanY) {
             if (minY < 0) {
                 throw new IllegalArgumentException("minY cannot be negative");
             }
@@ -310,7 +311,7 @@ public abstract class WorldType {
             return this;
         }
 
-        public Properties portalBounds(int minPortalY, int maxPortalY) {
+        public @NotNull Properties portalBounds(int minPortalY, int maxPortalY) {
             if (minPortalY < 0) {
                 throw new IllegalArgumentException("minPortalY cannot be negative");
             }
@@ -325,27 +326,27 @@ public abstract class WorldType {
             return this;
         }
 
-        public Properties oceanBlock(Block<?> oceanBlock) {
+        public @NotNull Properties oceanBlock(Block<?> oceanBlock) {
             this.oceanBlock = oceanBlock;
             return this;
         }
 
-        public Properties fillerBlock(Block<?> fillerBlock) {
+        public @NotNull Properties fillerBlock(Block<?> fillerBlock) {
             this.fillerBlock = fillerBlock;
             return this;
         }
 
-        public Properties dayNightCycleTicks(int ticks) {
+        public @NotNull Properties dayNightCycleTicks(int ticks) {
             this.dayNightCycleTicks = ticks;
             return this;
         }
 
-        public Properties allowRespawn() {
+        public @NotNull Properties allowRespawn() {
             this.mayRespawn = true;
             return this;
         }
 
-        public Properties setRetro() {
+        public @NotNull Properties setRetro() {
             this.isRetro = true;
             return this;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeGroups.java b/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeGroups.java
index 6045382e0..a5e9c23db 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeGroups.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeGroups.java
@@ -1,15 +1,13 @@
 package net.minecraft.core.world.type;
 
 import net.minecraft.core.world.Dimension;
+import org.jetbrains.annotations.NotNull;
 
-import java.util.ArrayList;
-import java.util.HashMap;
-import java.util.List;
-import java.util.Map;
+import java.util.*;
 
 public class WorldTypeGroups {
-    public static final List<Group> GROUPS = new ArrayList<>();
-    public static final Group DEFAULT = new Group(WorldTypes.OVERWORLD_EXTENDED);
+    public static final @NotNull List<@NotNull Group> GROUPS = new ArrayList<>();
+    public static final @NotNull Group DEFAULT = new Group(WorldTypes.OVERWORLD_EXTENDED);
 
     static {
         GROUPS.add(
@@ -73,16 +71,19 @@ public class WorldTypeGroups {
         private final Map<Dimension, WorldType> worldTypes = new HashMap<>();
 
         public Group(WorldType overworldType) {
-            worldTypes.put(Dimension.OVERWORLD, overworldType);
+            for (int i = 0; i < Dimension.getDimensionList().size(); i++) {
+                this.worldTypes.put(Dimension.getDimensionList().get(i), Objects.requireNonNull(Dimension.getDimensionList().get(i)).defaultWorldType);
+            }
+            this.worldTypes.put(Dimension.OVERWORLD, overworldType);
         }
 
-        public Group with(Dimension dimension, WorldType worldType) {
-            worldTypes.put(dimension, worldType);
+        public @NotNull Group with(Dimension dimension, WorldType worldType) {
+            this.worldTypes.put(dimension, worldType);
             return this;
         }
 
-        public WorldType get(Dimension dimension) {
-            return worldTypes.get(dimension);
+        public @NotNull WorldType get(Dimension dimension) {
+            return Objects.requireNonNull(this.worldTypes.get(dimension));
         }
     }
 }
